##################################################
#Project Name    : net_gogaku_recorder
#File Name       : net_gogaku_rec_(version No.)
#Encoding        : python3.9(inclueding GRC3.8)
#Creation Date   : 2022.5.28
#Release note:
#
#
#Copyright c 2021-2022 falconblog.org. All rights reserved.
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <https://www.gnu.org/licenses/>.
##################################################
import os
import sys
from PyQt5.QtWidgets import (QWidget,
    QVBoxLayout, QHBoxLayout, QApplication, QPushButton, QLabel, QLineEdit, QComboBox, QTextEdit)
from PyQt5.QtGui import QIcon
from PyQt5 import *
import subprocess
import configparser
import vlc
import platform
import threading
import schedule
import time, datetime
import requests
#import ffmpeg

# 初期設定値ファイルセット
inifile = configparser.ConfigParser()
inifile.read('settings_gogaku.ini',encoding='utf-8_sig')

class Radiru_rec(QWidget):

    def __init__(self):
        super().__init__()

#        self.initUI()
        # Create a basic vlc instance
        self.instance = vlc.Instance()

        self.media = None

        # Create an empty vlc media player
        self.mediaplayer = self.instance.media_player_new()

        self.initUI()
        self.is_paused = False

    def initUI(self):
        font=QtGui.QFont("00コミック7",14)
        font2=QtGui.QFont("00コミック7",10)

# ラベル名の設定
        global lbl7

        lbl2 = QLabel('録音番組選択')
        lbl2.setFont(font)
        lbl3 = QLabel('録音操作')
        lbl3.setFont(font)

        lbl6 = QLabel('予約する')
        lbl6.setFont(font)
        lbl7 = QTextEdit(inifile.get('CH1', 'week_comment'))
        lbl7.setFont(font2)
     
# ラジオボタングループ
        self.radioGroup = QtWidgets.QButtonGroup()

# 番組ボタン選択
        self.btn11=QtWidgets.QRadioButton(inifile.get('CH1', 'channel'),self)
        self.btn11.setChecked(True)
        self.btn11.setFont(font)
        self.btn11.setStyleSheet(inifile.get('CH1', 'back_color'))

        self.btn12=QtWidgets.QRadioButton(inifile.get('CH2', 'channel'),self)
        self.btn12.setChecked(False)
        self.btn12.setFont(font)
        self.btn12.setStyleSheet(inifile.get('CH2', 'back_color'))

        self.btn13=QtWidgets.QRadioButton(inifile.get('CH3', 'channel'),self)
        self.btn13.setChecked(False)
        self.btn13.setFont(font)
        self.btn13.setStyleSheet(inifile.get('CH3', 'back_color'))

        self.btn14=QtWidgets.QRadioButton(inifile.get('CH4', 'channel'),self)
        self.btn14.setChecked(False)
        self.btn14.setFont(font)
        self.btn14.setStyleSheet(inifile.get('CH4', 'back_color'))

        self.btn15=QtWidgets.QRadioButton(inifile.get('CH5', 'channel'),self)
        self.btn15.setChecked(False)
        self.btn15.setFont(font)
        self.btn15.setStyleSheet(inifile.get('CH5', 'back_color'))

        self.btn16=QtWidgets.QRadioButton(inifile.get('CH6', 'channel'),self)
        self.btn16.setChecked(True)
        self.btn16.setFont(font)
        self.btn16.setStyleSheet(inifile.get('CH6', 'back_color'))

        self.btn17=QtWidgets.QRadioButton(inifile.get('CH7', 'channel'),self)
        self.btn17.setChecked(False)
        self.btn17.setFont(font)
        self.btn17.setStyleSheet(inifile.get('CH7', 'back_color'))

        self.btn18=QtWidgets.QRadioButton(inifile.get('CH8', 'channel'),self)
        self.btn18.setChecked(False)
        self.btn18.setFont(font)
        self.btn18.setStyleSheet(inifile.get('CH8', 'back_color'))

        self.btn19=QtWidgets.QRadioButton(inifile.get('CH9', 'channel'),self)
        self.btn19.setChecked(False)
        self.btn19.setFont(font)
        self.btn19.setStyleSheet(inifile.get('CH9', 'back_color'))

        self.btn20=QtWidgets.QRadioButton(inifile.get('CH10', 'channel'),self)
        self.btn20.setChecked(False)
        self.btn20.setFont(font)
        self.btn20.setStyleSheet(inifile.get('CH10', 'back_color'))

# ラジオボタンオブジェクトのグループ登録
        self.radioGroup.addButton(self.btn11, 1)
        self.radioGroup.addButton(self.btn12, 2)
        self.radioGroup.addButton(self.btn13, 3)
        self.radioGroup.addButton(self.btn14, 4)
        self.radioGroup.addButton(self.btn15, 5)
        self.radioGroup.addButton(self.btn16, 6)
        self.radioGroup.addButton(self.btn17, 7)
        self.radioGroup.addButton(self.btn18, 8)
        self.radioGroup.addButton(self.btn19, 9)
        self.radioGroup.addButton(self.btn20, 10)
# ラジオボタン初期値設定
        global lbl21,lbl41,lbl61,lbl71
        self.btn11.setChecked(True)
        lbl21 = str(inifile.get('CH1', 'stime'))
        lbl41 = str(inifile.get('CH1', 'dulation'))
        lbl61 = str(inifile.get('CH1', 'file_name'))
        lbl71 = str(inifile.get('CH1', 'week_table'))
        self.week_select(int(lbl71), lbl21)
# 放送受信ボタン設定1
        self.btn4=QPushButton("現在のネット放送を聴く")
        self.btn4.setCheckable(False)
        self.btn4.setFont(font)
        self.btn4.setStyleSheet("background-color: #ffcf54")

# 放送予約ボタン設定1        
        self.btn6=QPushButton("録音予約する")
        self.btn6.setCheckable(False)
        self.btn6.setFont(font)
#        btn6.setStyleSheet("background-color: #ffcf54")
        self.btn6.setStyleSheet("background-color: #ff6d86")

# レイアウト設定        

        secondlayout=QVBoxLayout()
        secondlayout.addWidget(lbl2)
        secondlayout.addWidget(self.btn11)
        secondlayout.addWidget(self.btn12)
        secondlayout.addWidget(self.btn13)
        secondlayout.addWidget(self.btn14)
        secondlayout.addWidget(self.btn15)
        secondlayout.addWidget(self.btn16)
        secondlayout.addWidget(self.btn17)
        secondlayout.addWidget(self.btn18)
        secondlayout.addWidget(self.btn19)
        secondlayout.addWidget(self.btn20)
        
        thirdlayout=QVBoxLayout()
        thirdlayout.addWidget(lbl3)


        sixlayout_a=QHBoxLayout()
        sixlayout_a.addWidget(self.btn4)

        sixlayout_b=QHBoxLayout()
        sixlayout_b.addWidget(self.btn6)

        sevenlayout=QVBoxLayout()
        sevenlayout.addWidget(lbl7)

# レイアウト構築        
        layout=QVBoxLayout()

        layout.addLayout(secondlayout)
        layout.addLayout(thirdlayout)

        layout.addLayout(sixlayout_a)

        layout.addLayout(sevenlayout)
        layout.addLayout(sixlayout_b)
        
        self.setLayout(layout)

# ボタンクリック挙動設定
        self.btn11.clicked[bool].connect(self.buttonClicked_1)
        self.btn12.clicked[bool].connect(self.buttonClicked_2)
        self.btn13.clicked[bool].connect(self.buttonClicked_3)
        self.btn14.clicked[bool].connect(self.buttonClicked_4)
        self.btn15.clicked[bool].connect(self.buttonClicked_5)
        self.btn16.clicked[bool].connect(self.buttonClicked_6)
        self.btn17.clicked[bool].connect(self.buttonClicked_7)
        self.btn18.clicked[bool].connect(self.buttonClicked_8)
        self.btn19.clicked[bool].connect(self.buttonClicked_9)
        self.btn20.clicked[bool].connect(self.buttonClicked_10)
#

        self.btn4.clicked[bool].connect(self.play_pause)

        self.btn6.setCheckable(True)        
        self.btn6.toggled.connect(self.start_toggle)


# タイトル、ウィンドウ位置設定        
        self.setWindowTitle('ネット語学Recorder ver.1.0 (C)falcon')
        self.setGeometry(400, 100, 450, 400)

## VLC ui更新 Qt-timer　
        self.timer = QtCore.QTimer(self)
        self.timer.setInterval(100)
        self.timer.timeout.connect(self.update_ui)

# schedule マルチスレッド制御
        self.running = True
        self.job_enable = False
        self.thread = threading.Thread(target=self.run_monitor)
        self.thread.setDaemon(True)
        self.thread.start()

# 番組変数設定
    def buttonClicked_1(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH1', 'stime'))
        lbl41 = str(inifile.get('CH1', 'dulation'))
        lbl61 = str(inifile.get('CH1', 'file_name'))
        lbl71 = str(inifile.get('CH1', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH1', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_2(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH2', 'stime'))
        lbl41 = str(inifile.get('CH2', 'dulation'))
        lbl61 = str(inifile.get('CH2', 'file_name'))
        lbl71 = str(inifile.get('CH2', 'week_table'))    
        lbl7.clear()
        lbl7.append(inifile.get('CH2', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_3(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH3', 'stime'))
        lbl41 = str(inifile.get('CH3', 'dulation'))
        lbl61 = str(inifile.get('CH3', 'file_name'))
        lbl71 = str(inifile.get('CH3', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH3', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_4(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH4', 'stime'))
        lbl41 = str(inifile.get('CH4', 'dulation'))
        lbl61 = str(inifile.get('CH4', 'file_name'))
        lbl71 = str(inifile.get('CH4', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH4', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_5(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH5', 'stime'))
        lbl41 = str(inifile.get('CH5', 'dulation'))
        lbl61 = str(inifile.get('CH5', 'file_name'))
        lbl71 = str(inifile.get('CH5', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH5', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_6(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH6', 'stime'))
        lbl41 = str(inifile.get('CH6', 'dulation'))
        lbl61 = str(inifile.get('CH6', 'file_name'))
        lbl71 = str(inifile.get('CH6', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH6', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_7(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH7', 'stime'))
        lbl41 = str(inifile.get('CH7', 'dulation'))
        lbl61 = str(inifile.get('CH7', 'file_name'))
        lbl71 = str(inifile.get('CH7', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH7', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_8(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH8', 'stime'))
        lbl41 = str(inifile.get('CH8', 'dulation'))
        lbl61 = str(inifile.get('CH8', 'file_name'))
        lbl71 = str(inifile.get('CH8', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH8', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_9(self,pressed):
        global lbl21,lbl41,lbl61,lbl71
        lbl21 = str(inifile.get('CH9', 'stime'))
        lbl41 = str(inifile.get('CH9', 'dulation'))
        lbl61 = str(inifile.get('CH9', 'file_name'))
        lbl71 = str(inifile.get('CH9', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH9', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
    def buttonClicked_10(self,pressed):
        global lbl21,lbl41,lbl61,lbl71,lbl7
        lbl21 = str(inifile.get('CH10', 'stime'))
        lbl41 = str(inifile.get('CH10', 'dulation'))
        lbl61 = str(inifile.get('CH10', 'file_name'))
        lbl71 = str(inifile.get('CH10', 'week_table'))
        lbl7.clear()
        lbl7.append(inifile.get('CH10', 'week_comment'))
        self.week_select(int(lbl71), lbl21)
        

######################
# 録音module
    def rec(self):
        """recording player
        """
        self.mediaplayer.stop()
#        FFMPEG = "c:\\ffmpeg\\bin\\ffmpeg"
        FFMPEG = str(inifile.get('SECTION1', 'ffmpegdir'))
        PATH = inifile.get('SECTION1', 'data4')
        FILENAME = str(lbl61)
        duration = str(int(lbl41)*60)
        now = datetime.datetime.now()
        outfile =  PATH + FILENAME + now.strftime('_%Y%m%d_%H%M') + '.m4a'
#        print(duration, outfile)
#        streamurl = 'https://radio-stream.nhk.jp/hls/live/2023501/nhkradiruakr2/master.m3u8'
        streamurl = str(inifile.get('SECTION1', 'streamurl'))
        cmd = FFMPEG + ' -i {} -t {} -acodec copy -y {} -loglevel error'.format(streamurl,duration,outfile)
        lbl7.append('録音中です ' + str(duration) + ' 秒')
        subprocess.call(cmd)
        lbl7.append('録音終了' + now.strftime(' %Y%m%d_%H%M'))

#####################
# 再生module
    def play_pause(self):
        """Toggle play/pause status
        """
        if self.mediaplayer.is_playing():
#            self.mediaplayer.pause()
#            self.btn4.setText("停止")
#
            self.mediaplayer.stop()
            self.btn4.setText("現在のネット放送を聴く")
#
            self.is_paused = True
            self.timer.stop()
        else:
            if self.mediaplayer.play() == -1:
                self.open_file()
                return

            self.mediaplayer.play()
            time.sleep(5) # Or however long you expect it to take to open vlc
            self.btn4.setText("再生を停止")
            self.timer.start()
            self.is_paused = False

    def stop(self):
        """Stop player
        """
        self.mediaplayer.stop()
        self.btn4.setText("ネット接続を再確認")


    def open_file(self):
        """Open a media file in a MediaPlayer
        """
        #check for URL access
        try:
            response = requests.get(str(inifile.get('SECTION1', 'streamurl')))
            response.raise_for_status()
        except requests.exceptions.RequestException as e:
            lbl7.append('ネットラジオにアクセスできません！')
        else:
            pass

        # getOpenFileName returns a tuple, so use only the actual file name
        self.media = self.instance.media_new(str(inifile.get('SECTION1', 'streamurl')))
#        self.media = self.instance.media_new("https://radio-stream.nhk.jp/hls/live/2023501/nhkradiruakr2/master.m3u8")

        # Put the media in the media player
        self.mediaplayer.set_media(self.media)

        # Parse the metadata of the file
        self.media.parse()

        self.play_pause()

    def set_volume(self, volume):
        """Set the volume
        """
        self.mediaplayer.audio_set_volume(volume)

    def set_position(self):
        """Set the movie position according to the position slider.
        """
        # Set the media position to where the slider was dragged
        self.timer.stop()
        pos = self.positionslider.value()
        self.mediaplayer.set_position(pos / 1000.0)
        self.timer.start()

    def update_ui(self):
        """Updates the user interface"""

        # No need to call this function if nothing is played
        if not self.mediaplayer.is_playing():
            self.timer.stop()

            # After the video finished, the play button stills shows "Pause",
            # which is not the desired behavior of a media player.
            # This fixes that "bug".
            if not self.is_paused:
                self.stop()

##################################
#schedule thread contoroll section
    def run_monitor(self):
        while self.running:
            schedule.run_pending()
            time.sleep(0.2)
        pass

    def job(self):
        if self.job_enable:
            self.rec()

    def quit(self):
        self.running = False

    def start_toggle(self, checked):
        if checked:
            self.job_enable = True
            lbl7.append('予約を開始しました')
            self.btn_disable()
            self.btn6.setText("録音予約をキャンセル")
            
        else:
            self.job_enable = False
            self.btn6.setText("録音予約する")
            self.btn_enable()
            lbl7.append('予約をキャンセルしました')

    def btn_enable(self):
        self.btn4.setEnabled(True)
        self.btn11.setEnabled(True)
        self.btn12.setEnabled(True)
        self.btn13.setEnabled(True)
        self.btn14.setEnabled(True)
        self.btn15.setEnabled(True)
        self.btn16.setEnabled(True)
        self.btn17.setEnabled(True)
        self.btn18.setEnabled(True)
        self.btn19.setEnabled(True)
        self.btn20.setEnabled(True)

    def btn_disable(self):
        self.btn4.setEnabled(False)
        self.btn11.setEnabled(False)
        self.btn12.setEnabled(False)
        self.btn13.setEnabled(False)
        self.btn14.setEnabled(False)
        self.btn15.setEnabled(False)
        self.btn16.setEnabled(False)
        self.btn17.setEnabled(False)
        self.btn18.setEnabled(False)
        self.btn19.setEnabled(False)
        self.btn20.setEnabled(False)

######################        
# スケジュール設定 module
# 1: 月－金　
# 2: 月－水
# 3: 月火
# 4: 木金
# 5: 土日
# 6: 土
# 7: 日
# 8: 70秒
    def week_select(self, WEEK_NO, s_time):
        schedule.clear()
        if WEEK_NO == 0:
            schedule.every().day.at(s_time).do(self.job)
        elif WEEK_NO == 1:
            schedule.every().monday.at(s_time).do(self.job)
            schedule.every().tuesday.at(s_time).do(self.job)
            schedule.every().wednesday.at(s_time).do(self.job)
            schedule.every().thursday.at(s_time).do(self.job)
            schedule.every().friday.at(s_time).do(self.job)
        elif WEEK_NO == 2:
            schedule.every().monday.at(s_time).do(self.job)
            schedule.every().tuesday.at(s_time).do(self.job)
            schedule.every().wednesday.at(s_time).do(self.job)
        elif WEEK_NO == 3:
            schedule.every().monday.at(s_time).do(self.job)
            schedule.every().tuesday.at(s_time).do(self.job)
        elif WEEK_NO == 4:
            schedule.every().thursday.at(s_time).do(self.job)
            schedule.every().friday.at(s_time).do(self.job)
        elif WEEK_NO == 5:
            schedule.every().saturday.at(s_time).do(self.job)
            schedule.every().sunday.at(s_time).do(self.job)
        elif WEEK_NO == 6:
            schedule.every().saturday.at(s_time).do(self.job)
        elif WEEK_NO == 7:
            schedule.every().sunday.at(s_time).do(self.job)
        elif WEEK_NO == 8:
            schedule.every(70).seconds.do(self.job)

# QIcon設定
def ico_path(relative_path):
    try:
        base_path = sys._MEIPASS
    except Exception:
        base_path = os.path.abspath(".")
    return os.path.join(base_path, relative_path)

def main():
    app = QApplication(sys.argv)
    app.setWindowIcon(QIcon(ico_path('falcon.ico')))
    main_window = Radiru_rec()
    main_window.show()
    sys.exit(app.exec_())

if __name__ == '__main__':
    main()
    